---
title: WebGL2RenderingContext.getActiveUniforms()
slug: Web/API/WebGL2RenderingContext/getActiveUniforms
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.getActiveUniforms()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2 API</a> retrieves information about active uniforms within a {{domxref("WebGLProgram")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">any <var>gl</var>.getActiveUniforms(<var>program</var>, <var>uniformIndices</var>, <var>pname</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>program</code></dt>
 <dd>A {{domxref("WebGLProgram")}} containing the active uniforms.</dd>
 <dt><code>uniformIndices</code></dt>
 <dd>An {{jsxref("Array")}} of {{domxref("GLuint")}} specifying the indices of the active uniforms to query.</dd>
 <dt><code>pname</code></dt>
 <dd>A {{domxref("GLenum")}} specifying which information to query. Possible values:
 <ul>
  <li><code>gl.UNIFORM_TYPE</code>: Returns an {{jsxref("Array")}} of {{domxref("GLenum")}} indicating the <a href="/en-US/docs/Web/API/WebGLRenderingContext/getUniform#Return_value">types of the uniforms</a>.</li>
  <li><code>gl.UNIFORM_SIZE</code>: Returns an {{jsxref("Array")}} of {{domxref("GLuint")}} indicating the sizes of the uniforms.</li>
  <li><code>gl.UNIFORM_BLOCK_INDEX</code>: Returns an {{jsxref("Array")}} of {{domxref("GLint")}} indicating the block indices of the uniforms.</li>
  <li><code>gl.UNIFORM_OFFSET</code>: Returns an {{jsxref("Array")}} of {{domxref("GLint")}} indicating the uniform buffer offsets.</li>
  <li><code>gl.UNIFORM_ARRAY_STRIDE</code>: Returns an {{jsxref("Array")}} of {{domxref("GLint")}} indicating the strides between the elements.</li>
  <li><code>gl.UNIFORM_MATRIX_STRIDE</code>: Returns an {{jsxref("Array")}} of {{domxref("GLint")}} indicating the strides between columns of a column-major matrix or a row-major matrix.</li>
  <li><code>gl.UNIFORM_IS_ROW_MAJOR</code>: Returns an {{jsxref("Array")}} of {{domxref("GLboolean")}} indicating whether each of the uniforms is a row-major matrix or not.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Depends on which information is requested using the <code>pname</code> parameter.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var uniformIndices = gl.getUniformIndices(program, ['UBORed', 'UBOGreen', 'UBOBlue']);
var uniformOffsets = gl.getActiveUniforms(program, uniformIndices, gl.UNIFORM_OFFSET);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.16", "getActiveUniforms")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glGetActiveUniformsiv.xhtml", "glGetActiveUniformsiv")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.getActiveUniforms")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGL2RenderingContext.getActiveUniformBlockParameter()")}}</li>
</ul>
